#ObserverSwarm.py
from ModelSwarm import *
from Tools import *
from Agent import *
from ActionGroup import *

cycle=1

class ObserverSwarm:

    # create objects
    def buildObjects(self):
        global cycle
        cycle=1
        self.nAgents = input("How many 'vanilla' agents? ")
        self.worldXSize= input("X Size of the world? ")
        self.worldYSize= input("Y Size of the world? ")
        self.nCycles = input("How many cycles? (0 = exit) ")
        self.conclude=False

        self.modelSwarm = ModelSwarm(self.nAgents,
                           self.worldXSize, self.worldYSize)
        self.modelSwarm.buildObjects()


    # actions
    def buildActions(self):

        self.modelSwarm.buildActions()

        self.actionGroup1 = ActionGroup ("clock")
        def do1(address, nCycles, actionList):
            global cycle

            cycle+=1 #the clock running
            print "Time =%2d" % cycle
            if cycle>nCycles:
                 insertElementNextPosition(actionList,"end")

        self.actionGroup1.do = do1 # do is a variable linking a method
    
        self.actionGroup2a = ActionGroup ("talk all")
        def do2a(address):
            
            # ask each agent, without parameters

            print "Time = ", cycle, "ask all agents to report position"
            askEachAgentIn(address.modelSwarm.getAgentList(),Agent.reportPosition)
                     
        self.actionGroup2a.do = do2a # do is a variable linking a method
    
        self.actionGroup2b = ActionGroup ("talk one")
        def do2b(address):
            # ask a single agent, without parameters
            print "Time = ",cycle,"ask first agent to report position"
            if address.modelSwarm.getAgentList() != []:
                askAgent(address.modelSwarm.getAgentList()[0],\
                         Agent.reportPosition)
                     
        self.actionGroup2b.do = do2b # do is a variable linking a method

        self.actionGroup3 = ActionGroup ("end")
        def do3(address):
            self.conclude=True
        self.actionGroup3.do = do3 # do is a variable linking a method

        # schedule
        #self.actionList = [["modelStep", "talk all", "clock"], \
        #                   ["modelStep", "talk one", "clock"], \
        #                   ["modelStep", "talk one", "clock"] ]
        #or
        self.actionList = [["modelStep"], ["talk all"], ["clock"], \
                           ["modelStep"], ["talk one"], ["clock"], \
                           ["modelStep"], ["talk one"], ["clock"] ]
        

    # run
    def run(self):
        global cycle
        print "Time =%2d" % cycle


        while not self.conclude:
           
            step=extractAStepAndRotate(self.actionList)

            while len(step)>0 and not self.conclude:
                subStep=extractASubStep(step)

                if subStep == "modelStep":
                    self.modelSwarm.step(cycle)
                    # in a reasonable way, the model makes a step before
                    # that the observer looks at the effects of model actions
 
                if subStep == "clock":
                    self.actionGroup1.do(self, self.nCycles, self.actionList)
                    # self here is the model env.
                    # not added automatically
                    # being do a variable
 
                if subStep == "talk all":
                    self.actionGroup2a.do(self)

                if subStep == "talk one":
                    self.actionGroup2b.do(self)

                if subStep == "end":
                    self.actionGroup3.do(self)

        if self.modelSwarm.getFile() != "": self.modelSwarm.getFile().close()
